/*******************************************************************
 * Xatm -- OCF, CID, TrueType scalable font support for X 
 *  By:  ͵ <y5t0964@students.chiba-u.ac.jp>
 */

/* string_ut.c */

/* $Id: string_ut.c,v 1.5 1998/05/31 15:16:20 elca Exp elca $ */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "Xatm.h"

/*#define dprintf(str) fprintf str */
#define dprintf(str) /* */

/* ʸʸΰ㤤̵뤹 strstr() */
char * strcasestr(char *haystack, const char *needle)
{
	char *haystackbuf;
	char *needlebuf;
	int i;
	char *ptr;
	char *ret;

	haystackbuf = strdup(haystack);
	needlebuf = strdup(needle);
	if(haystackbuf == NULL || needlebuf == NULL) {
		free(haystackbuf);
		free(needlebuf);
		return NULL;
	}

	/* change to lower case */
	for(i = 0; haystackbuf[i] != 0; i++) {
		haystackbuf[i] = (char)tolower(haystackbuf[i]);
	}
	for(i = 0; needlebuf[i] != 0; i++) {
		needlebuf[i] = (char)tolower(needlebuf[i]);
	}

	ptr = strstr(haystackbuf, needlebuf);

	if(ptr == NULL) {
		ret = NULL;
	} else {
		ret = (ptr - haystackbuf) + haystack;
	}

	dprintf((stdout, "hay %s->%s, need %s->%s, ret %d\n",
		 haystack, haystackbuf,
		 needle, needlebuf, ret));

	free(haystackbuf);
	free(needlebuf);

	return ret;
}

/* end */
